<?php require "../top.inc.php"; ?>

<p>
	Ajouter un domaine sur un dossier de site<br>
	Le domaine doit pointer vers ces adresses IP :
	<br>IPv4 : <code><?= IPV4_ADDRESS ?></code>
	<br>IPv6 : <code><?= IPV6_ADDRESS ?></code>
</p>

<form method="post">
	<label for="domain">Domaine sur lequel répondre</label><br>
	<input required="" placeholder="site.<?= DOMAIN_EXAMPLE ?>" id="domain" name="domain" type="text"><br>
	<label for="dir">Dossier ciblé</label><br>
	<select required="" name="dir" id="dir">
		<option value="" disabled="" selected="">---</option>

		<?php

		$fsDirs = listFsDirs($_SESSION['username']);
		$dbUsedDirs = listDbDirs($_SESSION['username'], "dns", "http");
		$i = 0;
		$j = 0;
		$alreadyEnabledDirs = NULL;
		$notYetEnabledDirs = NULL;
		if ($fsDirs) {
			foreach ($fsDirs as $fsDir) {
				if ($dbUsedDirs AND in_array($fsDir, $dbUsedDirs)) {
					$alreadyEnabledDirs[$i] = $fsDir;
					$i++;
				} else {
					$notYetEnabledDirs[$j] = $fsDir;
					$j++;
				}
			}

			if (!is_null($notYetEnabledDirs)) {
				foreach ($notYetEnabledDirs as $dir) {
					echo "<option value='" . $dir . "'>" . $dir . "</option>";
				}
			}

			if (!is_null($alreadyEnabledDirs)) {
				foreach ($alreadyEnabledDirs as $dir) {
					echo "<option disabled='' value='" . $dir . "'>" . $dir . "</option>";
				}
			}
		}

		?>
	</select>
	<br>
	<input value="Valider" type="submit">
</form>

<?php

if (isset($_POST['domain']) AND isset($_POST['dir']) AND isset($_SESSION['username'])) {

	antiCSRF();

	checkDomainFormat($_POST['domain']);

	if (!in_array($_POST['dir'], $notYetEnabledDirs))
		exit("ERROR : Wrong value for dir");

	addSite($_SESSION['username'], $_POST['dir'], $_POST['domain'], "dns", "http");

	$nginxConf = file_get_contents(NIVER_TEMPLATE_PATH . "/nginx/dns.template");
	$nginxConf = str_replace("{{HTTPS_PORT}}", HTTPS_PORT, $nginxConf);
	$nginxConf = str_replace("{{DOMAIN}}", $_POST['domain'], $nginxConf);
	$nginxConf = str_replace("{{HT_PATH}}", HT_PATH, $nginxConf);
	$nginxConf = str_replace("{{USERNAME}}", $_SESSION['username'], $nginxConf);
	$nginxConf = str_replace("{{DIR}}", $_POST['dir'], $nginxConf);
	file_put_contents(NGINX_CONFIG_PATH . "/" . $_POST['domain'] . ".conf", $nginxConf);

	// Reload Nginx
	exec(SUDO_PATH . " " . MANIVER_PATH . " reload-nginx");

	echo "Accès HTTP par domaine ajouté sur ce dossier !";
}

?>

<?php require "../bottom.inc.php"; ?>
