<?php
if (strpos($_SERVER['PHP_SELF'], "inc.php") !== false)
	exit("This file is meant to be included.");

function checkIpFormat($ip) {
	if (!filter_var($ip, FILTER_VALIDATE_IP))
		exit("ERROR: wrong IP address");
	if (!filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_NO_PRIV_RANGE))
		exit("ERROR: IP address is on the private range");
	if (!filter_var($ip, FILTER_VALIDATE_IP, FILTER_FLAG_NO_RES_RANGE))
		exit("ERROR: IP address is on the reserved range");
}

function checkAbsoluteDomainFormat($domain) {
	// If the domain must end with a dot
	if (!filter_var($domain, FILTER_VALIDATE_DOMAIN) OR !preg_match("/^([a-z0-9_-]{1,63}\.){2,127}$/", $domain))
		exit("ERROR: wrong domain");
}

function checkDomainFormat($domain) {
	// If the domain must end without a dot
	if (!filter_var($domain, FILTER_VALIDATE_DOMAIN) OR !preg_match("/^([a-z0-9_-]{1,63}\.){1,126}[a-z0-9]{1,63}$/", $domain))
		exit("ERROR: wrong domain");
}

function checkPasswordFormat($password) {
	return preg_match("/" . PASSWORD_REGEX . "/", $password);
}

function checkUsernameFormat($username) {
	return preg_match("/" . USERNAME_REGEX . "/", $username);
}
