<?php require "../top.inc.php"; ?>

<p>
	Ici vous pouvez ajouter ou enlever des adresses IP dans une zone déjà enregistrée sur le serveur de noms de Niver
	<br>Le format IPv4 (<code>A</code>) ou IPv6 (<code>AAAA</code>) sera détecté automatiquement.
	<br>Si vous souhaitez utiliser un service d'hébergement hypertexte de Niver, voici les adresses à renseigner :
	<br>IPv4 : <code><?= IPV4_ADDRESS ?></code>
	<br>IPv6 : <code><?= IPV6_ADDRESS ?></code>
</p>

<form method="post">
	<?php require "../inc/form/form.ns.inc.php"; ?>
	<label for="ip">Adresse IP</label><br>
	<input required="" pattern="^[a-f0-9:.]+$" id="ip" name="ip" minlength="7" maxlength="39" size="40" type="text" placeholder="<?= IPV6_EXAMPLE ?> ou <?= IPV4_EXAMPLE ?>"><br>
	<input value="Valider" type="submit">
</form>

<?php
if (nsCommonRequirements()
		AND isset($_POST['ip'])
	) {

	$values = nsParseCommonRequirements();

	checkIpFormat($_POST['ip']);

	if (filter_var($_POST['ip'], FILTER_VALIDATE_IP, FILTER_FLAG_IPV4))
		$record = "A";
	else if (filter_var($_POST['ip'], FILTER_VALIDATE_IP, FILTER_FLAG_IPV6))
		$record = "AAAA";
	else
		exit("ERROR: unknown IP format");

	exec(KNOTC_PATH . " zone-begin " . $_POST['zone']);
	exec(KNOTC_PATH . " zone-" . $values['action'] . "set " . $_POST['zone'] . " " . $values['domain'] . " " . $values['ttl'] . " IN " . $record . " " . $_POST['ip']);
	exec(KNOTC_PATH . " zone-commit " . $_POST['zone']);

	echo "Enregistrement ajouté";
}

?>

<?php require "../bottom.inc.php"; ?>
