<?php require "../top.inc.php"; ?>

<form method="post">
	<label for="action">Action</label>
	<select name="action" id="action">
		<option value="add">Ajouter</option>
		<option value="delete">Retirer</option>
	</select>
	<fieldset>
		<legend>Domaine</legend>
		<div class="elForm">
			<label for="subdomain">Sous-domaine</label>
			<br>
			<input required="" id="subdomain" placeholder="ns1" name="subdomain" type="text">
		</div>
		<div class="elForm">
			<label for="suffix">Domaine</label>
			<br>
			<select required="" name="suffix" id="suffix">
				<option value="" disabled="" selected="">---</option>

				<?php

				$suffixes = regListUserDomains($_SESSION['username']);

				if ($suffixes) {
					foreach($suffixes as $suffix) {
						echo "<option value='" . $suffix . "'>." . $suffix . "</option>";
					}
				}

				?>
			</select>
		</div>
	</fieldset>
	<label for="ip">IP</label><br>
	<input required="" pattern="^[a-f0-9:.]+$" id="ip" name="ip" minlength="7" maxlength="39" size="40" type="text" placeholder="<?= IPV4_EXAMPLE ?> ou <?= IPV6_EXAMPLE ?>">
	<br>
	<input value="Valider" type="submit">
</form>

<?php

if (isset($_POST['action']) AND isset($_POST['subdomain']) AND isset($_POST['suffix']) AND isset($_POST['ip']) AND isset($_SESSION['username'])) {

	antiCSRF();

	if (!$suffixes)
		exit("ERROR : You don't own any domain");

	if (!in_array($_POST['suffix'], $suffixes))
		exit("ERROR : You don't own this suffix");

	$domain = $_POST['subdomain'] . "." . $_POST['suffix'];

	checkAbsoluteDomainFormat($domain);

	checkIpFormat($_POST['ip']);

	if (filter_var($_POST['ip'], FILTER_VALIDATE_IP, FILTER_FLAG_IPV4))
		$record = "A";
	else if (filter_var($_POST['ip'], FILTER_VALIDATE_IP, FILTER_FLAG_IPV6))
		$record = "AAAA";
	else
		exit("Unknown error about IP format");

	$action = checkAction($_POST['action']);

	$publicSuffix = regGetUpperDomain($_POST['suffix']);

	exec(KNOTC_PATH . " zone-begin " . $publicSuffix);
	exec(KNOTC_PATH . " zone-" . $action . "set " . $publicSuffix . " " . $domain . " 86400 IN " . $record . " " . $_POST['ip']);
	exec(KNOTC_PATH . " zone-commit " . $publicSuffix);
	echo "Glue record ajouté";
}

?>

<?php require "../bottom.inc.php"; ?>
