<?php include "../top.inc.php"; ?>

Enregistrer la possession d'un domaine sur son compte.<br>
Ce domaine doit être composé uniquement d'au moins 4 lettres latines non accentuées.
<br>
<br>
<form method="post">
	<fieldset>
		<legend>Domaine</legend>
		<div>
			<label for="subdomain">Sous-domaine</label>
			<br>
			<input id="subdomain" pattern="<?= SUBDOMAIN_REGEX ?>" required="" placeholder="niver" name="subdomain" type="text">
		</div>
		<div>
			<label for="suffix">Suffixe</label>
			<br>
			<select required="" id="suffix" name="suffix">
				<option selected="" value="<?= REGISTRY ?>">.<?= REGISTRY ?></option>
			</select>
		</div>
	</fieldset>
	<br>
	<input value="Valider" type="submit">
</form>

<?php

if (isset($_POST['subdomain']) AND isset($_POST['suffix']) AND isset($_SESSION['username'])) {

	antiCSRF();

	if (preg_match("/" . SUBDOMAIN_REGEX . "/", $_POST['subdomain'])) {

		if (!in_array($_POST['suffix'], SUFFIXES))
			exit("Wrong value for suffix");

		$domain = $_POST['subdomain'] . "." . $_POST['suffix'];

		checkAbsoluteDomainFormat($domain);

		if (regIsFree($domain)) {
			$db = new PDO('sqlite:' . DB_PATH);
			$stmt = $db->prepare("INSERT INTO registry(domain, username, last_renewal) VALUES(:domain, :username, :last_renewal)");
			$username = $_SESSION['username'];

			$time = date("Y-m-d H:i:s");

			$stmt->bindParam(':domain', $domain);
			$stmt->bindParam(':username', $username);
			$stmt->bindParam(':last_renewal', $time);

			$stmt->execute();

			echo "Nouveau domaine enregistré";

		} else {
			echo "Le domaine " . $domain . " n'est pas disponible à l'enregistrement. Il est réservé ou déjà enregistré.";
		}
	} else {
		echo "Erreur : Le nom de domaine doit être composé uniquement d'entre 4 et 63 lettres minuscules (a-z)";
	}
}

?>

<?php include "../bottom.inc.php"; ?>
